Index: code/branches/pickup2/src/libraries/core/TclBind.h
===================================================================
--- code/branches/pickup2/src/libraries/core/TclBind.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/TclBind.h	(revision 6412)
@@ -46,5 +46,5 @@
 
             static std::string tcl(const std::string& tclcode);
-            static void bgerror(std::string error);
+            static void bgerror(const std::string& error);
 
             void setDataPath(const std::string& datapath);
Index: code/branches/pickup2/src/libraries/core/TclThreadManager.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/TclThreadManager.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/TclThreadManager.cc	(revision 6412)
@@ -39,4 +39,5 @@
 #include "util/Convert.h"
 #include "util/Exception.h"
+#include "util/StringUtils.h"
 #include "CommandExecutor.h"
 #include "ConsoleCommand.h"
@@ -122,5 +123,5 @@
         @brief The "main loop" of the TclThreadManager. Creates new threads if needed and handles queries and queued commands for the main interpreter.
     */
-    void TclThreadManager::update(const Clock& time)
+    void TclThreadManager::preUpdate(const Clock& time)
     {
         // Get the bundle of the main interpreter (0)
@@ -252,5 +253,5 @@
     void TclThreadManager::initialize(TclInterpreterBundle* bundle)
     {
-        std::string id_string = getConvertedValue<unsigned int, std::string>(bundle->id_);
+        const std::string& id_string = getConvertedValue<unsigned int, std::string>(bundle->id_);
 
         // Initialize the new interpreter
@@ -403,8 +404,8 @@
             {
                 // This query would lead to a deadlock - return with an error
-                TclThreadManager::error("Error: Circular query (" + this->dumpList(source_bundle->queriers_.getList()) + " " + getConvertedValue<unsigned int, std::string>(source_bundle->id_) \
+                TclThreadManager::error("Error: Circular query (" + this->dumpList(source_bundle->queriers_.getList()) + ' ' + getConvertedValue<unsigned int, std::string>(source_bundle->id_) \
                             + " -> " + getConvertedValue<unsigned int, std::string>(target_bundle->id_) \
                             + "), couldn't query Tcl-interpreter with ID " + getConvertedValue<unsigned int, std::string>(target_bundle->id_) \
-                            + " from other interpreter with ID " + getConvertedValue<unsigned int, std::string>(source_bundle->id_) + ".");
+                            + " from other interpreter with ID " + getConvertedValue<unsigned int, std::string>(source_bundle->id_) + '.');
             }
             else
@@ -524,9 +525,9 @@
     std::string TclThreadManager::dumpList(const std::list<unsigned int>& list)
     {
-        std::string output = "";
+        std::string output;
         for (std::list<unsigned int>::const_iterator it = list.begin(); it != list.end(); ++it)
         {
             if (it != list.begin())
-                output += " ";
+                output += ' ';
 
             output += getConvertedValue<unsigned int, std::string>(*it);
@@ -600,5 +601,5 @@
         @param command the Command to execute
     */
-    void tclThread(TclInterpreterBundle* bundle, std::string command)
+    void tclThread(TclInterpreterBundle* bundle, const std::string& command)
     {
         TclThreadManager::debug("TclThread_execute: " + command);
@@ -613,5 +614,5 @@
         @param file The name of the file that should be executed by the non-interactive interpreter.
     */
-    void sourceThread(std::string file)
+    void sourceThread(const std::string& file)
     {
         TclThreadManager::debug("TclThread_source: " + file);
@@ -651,7 +652,7 @@
 
         // Initialize the non-interactive interpreter (like in @ref TclBind::createTclInterpreter but exception safe)
-        std::string libpath = TclBind::getTclLibraryPath();
-        if (libpath != "")
-            TclThreadManager::eval(bundle, "set tcl_library \"" + libpath + "\"", "source");
+        const std::string& libpath = TclBind::getTclLibraryPath();
+        if (!libpath.empty())
+            TclThreadManager::eval(bundle, "set tcl_library \"" + libpath + '"', "source");
         int cc = Tcl_Init(interp);
         TclThreadManager::eval(bundle, "source \"" + TclBind::getInstance().getTclDataPath() + "/init.tcl\"", "source");
Index: code/branches/pickup2/src/libraries/core/TclThreadManager.h
===================================================================
--- code/branches/pickup2/src/libraries/core/TclThreadManager.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/TclThreadManager.h	(revision 6412)
@@ -48,6 +48,6 @@
         friend class Singleton<TclThreadManager>;
         friend class TclBind;
-        friend _CoreExport void tclThread(TclInterpreterBundle* bundle, std::string command);
-        friend _CoreExport void sourceThread(std::string file);
+        friend _CoreExport void tclThread(TclInterpreterBundle* bundle, const std::string& command);
+        friend _CoreExport void sourceThread(const std::string& file);
         friend _CoreExport int Tcl_OrxonoxAppInit(Tcl_Interp* interp);
 
@@ -66,5 +66,5 @@
             static void debug(const std::string& error);
 
-            void update(const Clock& time);
+            void preUpdate(const Clock& time);
 
             std::list<unsigned int> getThreadList() const;
@@ -95,6 +95,6 @@
     };
 
-    _CoreExport void tclThread(TclInterpreterBundle* bundle, std::string command);
-    _CoreExport void sourceThread(std::string file);
+    _CoreExport void tclThread(TclInterpreterBundle* bundle, const std::string& command);
+    _CoreExport void sourceThread(const std::string& file);
     _CoreExport int Tcl_OrxonoxAppInit(Tcl_Interp* interp);
 }
Index: code/branches/pickup2/src/libraries/core/Template.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/Template.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/Template.cc	(revision 6412)
@@ -79,5 +79,5 @@
         SUPER(Template, changedName);
 
-        if (this->getName() != "")
+        if (!this->getName().empty())
         {
             std::map<std::string, Template*>::iterator it;
Index: code/branches/pickup2/src/libraries/core/Template.h
===================================================================
--- code/branches/pickup2/src/libraries/core/Template.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/Template.h	(revision 6412)
@@ -48,5 +48,5 @@
 
             inline void setLink(const std::string& link)
-                { this->link_ = link; this->bIsLink_ = (link != ""); }
+                { this->link_ = link; this->bIsLink_ = !link.empty(); }
             inline const std::string& getLink() const
                 { return this->link_; }
Index: code/branches/pickup2/src/libraries/core/XMLFile.h
===================================================================
--- code/branches/pickup2/src/libraries/core/XMLFile.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/XMLFile.h	(revision 6412)
@@ -40,12 +40,10 @@
     {
         public:
-            XMLFile(const std::string& filename, const std::string& resourceGroup = "General")
+            XMLFile(const std::string& filename)
                 : filename_(filename)
-                , group_(resourceGroup)
                 , bLuaSupport_(true)
             { }
-            XMLFile(const ClassTreeMask& mask, const std::string& filename, const std::string& resourceGroup = "General")
+            XMLFile(const ClassTreeMask& mask, const std::string& filename)
                 : filename_(filename)
-                , group_(resourceGroup)
                 , mask_(mask)
                 , bLuaSupport_(true)
@@ -55,5 +53,4 @@
 
             const std::string& getFilename() const { return this->filename_; }
-            const std::string& getResourceGroup() const { return this->group_; }
             const ClassTreeMask& getMask() const { return this->mask_; }
             bool getLuaSupport() const { return this->bLuaSupport_; }
@@ -61,5 +58,4 @@
         private:
             std::string filename_;
-            std::string group_;
             ClassTreeMask mask_;
             bool bLuaSupport_; // Default is true
Index: code/branches/pickup2/src/libraries/core/XMLPort.h
===================================================================
--- code/branches/pickup2/src/libraries/core/XMLPort.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/XMLPort.h	(revision 6412)
@@ -51,4 +51,5 @@
 #include "util/MultiType.h"
 #include "util/OrxAssert.h"
+#include "util/StringUtils.h"
 #include "Identifier.h"
 #include "Executor.h"
@@ -184,5 +185,5 @@
         ClassIdentifier<classname>::getIdentifier()->addXMLPortParamContainer(paramname, containername); \
     } \
-    containername->port(static_cast<BaseObject*>(this), object, xmlelement, mode)
+    containername->port(dynamic_cast<BaseObject*>(this), object, xmlelement, mode)
 
 // --------------------
@@ -316,5 +317,5 @@
                 { return this->paramname_; }
 
-            virtual XMLPortParamContainer& description(const std::string description) = 0;
+            virtual XMLPortParamContainer& description(const std::string& description) = 0;
             virtual const std::string& getDescription() = 0;
 
@@ -344,5 +345,5 @@
 
         public:
-            XMLPortClassParamContainer(const std::string paramname, Identifier* identifier, ExecutorMember<T>* loadexecutor, ExecutorMember<T>* saveexecutor)
+            XMLPortClassParamContainer(const std::string& paramname, Identifier* identifier, ExecutorMember<T>* loadexecutor, ExecutorMember<T>* saveexecutor)
             {
                 this->paramname_ = paramname;
@@ -385,5 +386,5 @@
                         }
                         std::map<std::string, std::string>::const_iterator it = this->owner_->xmlAttributes_.find(getLowercase(this->paramname_));
-                        std::string attributeValue("");
+                        std::string attributeValue;
                         if (it != this->owner_->xmlAttributes_.end())
                             attributeValue = it->second;
@@ -407,5 +408,5 @@
                     {
                         COUT(1) << std::endl;
-                        COUT(1) << "An error occurred in XMLPort.h while loading attribute '" << this->paramname_ << "' of '" << this->identifier_->getName() << "' (objectname: " << this->owner_->getName() << ") in " << this->owner_->getFilename() << ":" << std::endl;
+                        COUT(1) << "An error occurred in XMLPort.h while loading attribute '" << this->paramname_ << "' of '" << this->identifier_->getName() << "' (objectname: " << this->owner_->getName() << ") in " << this->owner_->getFilename() << ':' << std::endl;
                         COUT(1) << ex.what() << std::endl;
                     }
@@ -435,5 +436,5 @@
             }
 
-            virtual XMLPortParamContainer& description(const std::string description)
+            virtual XMLPortParamContainer& description(const std::string& description)
                 { this->loadexecutor_->setDescription(description); return (*this); }
             virtual const std::string& getDescription()
@@ -497,5 +498,5 @@
                 { return this->sectionname_; }
 
-            virtual XMLPortObjectContainer& description(const std::string description) = 0;
+            virtual XMLPortObjectContainer& description(const std::string& description) = 0;
             virtual const std::string& getDescription() = 0;
 
@@ -513,5 +514,5 @@
     {
         public:
-            XMLPortClassObjectContainer(const std::string sectionname, Identifier* identifier, ExecutorMember<T>* loadexecutor, ExecutorMember<T>* saveexecutor, bool bApplyLoaderMask, bool bLoadBefore)
+            XMLPortClassObjectContainer(const std::string& sectionname, Identifier* identifier, ExecutorMember<T>* loadexecutor, ExecutorMember<T>* saveexecutor, bool bApplyLoaderMask, bool bLoadBefore)
             {
                 this->sectionname_ = sectionname;
@@ -538,5 +539,5 @@
                     {
                         Element* xmlsubelement;
-                        if ((this->sectionname_ != "") && (this->sectionname_.size() > 0))
+                        if (!this->sectionname_.empty())
                             xmlsubelement = xmlelement.FirstChildElement(this->sectionname_, false);
                         else
@@ -570,9 +571,9 @@
                                                     {
                                                         newObject->XMLPort(*child, XMLPort::LoadObject);
-                                                        COUT(4) << object->getLoaderIndentation() << "assigning " << child->Value() << " (objectname " << newObject->getName() << ") to " << this->identifier_->getName() << " (objectname " << static_cast<BaseObject*>(object)->getName() << ")" << std::endl;
+                                                        COUT(4) << object->getLoaderIndentation() << "assigning " << child->Value() << " (objectname " << newObject->getName() << ") to " << this->identifier_->getName() << " (objectname " << static_cast<BaseObject*>(object)->getName() << ')' << std::endl;
                                                     }
                                                     else
                                                     {
-                                                        COUT(4) << object->getLoaderIndentation() << "assigning " << child->Value() << " (object not yet loaded) to " << this->identifier_->getName() << " (objectname " << static_cast<BaseObject*>(object)->getName() << ")" << std::endl;
+                                                        COUT(4) << object->getLoaderIndentation() << "assigning " << child->Value() << " (object not yet loaded) to " << this->identifier_->getName() << " (objectname " << static_cast<BaseObject*>(object)->getName() << ')' << std::endl;
                                                     }
 
@@ -609,5 +610,5 @@
                                 else
                                 {
-                                    if (this->sectionname_ != "")
+                                    if (!this->sectionname_.empty())
                                     {
                                         COUT(2) << object->getLoaderIndentation() << "Warning: '" << child->Value() << "' is not a valid classname." << std::endl;
@@ -624,5 +625,5 @@
                     {
                         COUT(1) << std::endl;
-                        COUT(1) << "An error occurred in XMLPort.h while loading a '" << ClassIdentifier<O>::getIdentifier()->getName() << "' in '" << this->sectionname_ << "' of '" << this->identifier_->getName() << "' (objectname: " << object->getName() << ") in " << object->getFilename() << ":" << std::endl;
+                        COUT(1) << "An error occurred in XMLPort.h while loading a '" << ClassIdentifier<O>::getIdentifier()->getName() << "' in '" << this->sectionname_ << "' of '" << this->identifier_->getName() << "' (objectname: " << object->getName() << ") in " << object->getFilename() << ':' << std::endl;
                         COUT(1) << ex.what() << std::endl;
                     }
@@ -635,5 +636,5 @@
             }
 
-            virtual XMLPortObjectContainer& description(const std::string description)
+            virtual XMLPortObjectContainer& description(const std::string& description)
                 { this->loadexecutor_->setDescription(description); return (*this); }
             virtual const std::string& getDescription()
Index: code/branches/pickup2/src/libraries/core/input/Button.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/input/Button.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/input/Button.cc	(revision 6412)
@@ -116,5 +116,5 @@
         for (unsigned int iCommand = 0; iCommand < commandStrings.size(); iCommand++)
         {
-            if (commandStrings[iCommand] != "")
+            if (!commandStrings[iCommand].empty())
             {
                 SubString tokens(commandStrings[iCommand], " ", SubString::WhiteSpaces, false,
@@ -123,9 +123,9 @@
                 KeybindMode::Value mode = KeybindMode::None;
                 float paramModifier = 1.0f;
-                std::string commandStr = "";
+                std::string commandStr;
 
                 for (unsigned int iToken = 0; iToken < tokens.size(); ++iToken)
                 {
-                    std::string token = getLowercase(tokens[iToken]);
+                    const std::string& token = getLowercase(tokens[iToken]);
 
                     if (token == "onpress")
@@ -159,9 +159,9 @@
                         // we interpret everything from here as a command string
                         while (iToken != tokens.size())
-                            commandStr += tokens[iToken++] + " ";
-                    }
-                }
-
-                if (commandStr == "")
+                            commandStr += tokens[iToken++] + ' ';
+                    }
+                }
+
+                if (commandStr.empty())
                 {
                     parseError("No command string given.", false);
@@ -242,5 +242,5 @@
     }
 
-    inline void Button::parseError(std::string message, bool serious)
+    inline void Button::parseError(const std::string& message, bool serious)
     {
         if (serious)
Index: code/branches/pickup2/src/libraries/core/input/Button.h
===================================================================
--- code/branches/pickup2/src/libraries/core/input/Button.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/input/Button.h	(revision 6412)
@@ -76,5 +76,5 @@
 
     private:
-        void parseError(std::string message, bool serious);
+        void parseError(const std::string& message, bool serious);
     };
 
Index: code/branches/pickup2/src/libraries/core/input/InputBuffer.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/input/InputBuffer.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/input/InputBuffer.cc	(revision 6412)
@@ -39,6 +39,6 @@
         RegisterRootObject(InputBuffer);
 
-        this->buffer_ = "";
         this->cursor_ = 0;
+        this->maxLength_ = 1024;
         this->allowedChars_ = "abcdefghijklmnopqrstuvwxyz \
                                ABCDEFGHIJKLMNOPQRSTUVWXYZ \
@@ -59,6 +59,6 @@
         RegisterRootObject(InputBuffer);
 
+        this->maxLength_ = 1024;
         this->allowedChars_ = allowedChars;
-        this->buffer_ = "";
         this->cursor_ = 0;
 
@@ -80,5 +80,5 @@
     void InputBuffer::setConfigValues()
     {
-        SetConfigValue(keyRepeatDeleay_, 0.4).description("Key repeat deleay of the input buffer");
+        SetConfigValue(keyRepeatDeleay_, 0.4).description("Key repeat delay of the input buffer");
         SetConfigValue(keyRepeatTime_, 0.022).description("Key repeat time of the input buffer");
 
@@ -91,4 +91,11 @@
             ResetConfigValue(keyRepeatTime_);
         }
+    }
+
+    void InputBuffer::setMaxLength(unsigned int length)
+    {
+        this->maxLength_ = length;
+        if (this->buffer_.size() > length)
+            this->buffer_.resize(length);
     }
 
@@ -117,4 +124,6 @@
         if (this->charIsAllowed(input))
         {
+            if (this->buffer_.size() >= this->maxLength_)
+                return;
             this->buffer_.insert(this->cursor_, 1, input);
             ++this->cursor_;
@@ -127,5 +136,5 @@
     void InputBuffer::clear(bool update)
     {
-        this->buffer_ = "";
+        this->buffer_.clear();
         this->cursor_ = 0;
 
@@ -177,5 +186,5 @@
     bool InputBuffer::charIsAllowed(const char& input)
     {
-        if (this->allowedChars_ == "")
+        if (this->allowedChars_.empty())
             return true;
         else
@@ -186,4 +195,5 @@
     void InputBuffer::processKey(const KeyEvent& evt)
     {
+        // Prevent disaster when switching applications
         if (evt.isModifierDown(KeyboardModifier::Alt) && evt.getKeyCode() == KeyCode::Tab)
             return;
@@ -222,5 +232,5 @@
 
     /**
-        @brief This update() function is called by the InputManager if the InputBuffer is active.
+        @brief This update() function is called by the InputState if the InputBuffer is active.
         @param dt Delta time
     */
Index: code/branches/pickup2/src/libraries/core/input/InputBuffer.h
===================================================================
--- code/branches/pickup2/src/libraries/core/input/InputBuffer.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/input/InputBuffer.h	(revision 6412)
@@ -83,4 +83,7 @@
             void setConfigValues();
 
+            unsigned int getMaxLength() const { return this->maxLength_; }
+            void setMaxLength(unsigned int length);
+
             template <class T>
             void registerListener(T* listener, void (T::*function)(), bool bOnlySingleInput)
@@ -162,8 +165,9 @@
                 { if (this->cursor_ > 0) { --this->cursor_; } }
 
+            void buttonPressed(const KeyEvent& evt);
+
         private:
             bool charIsAllowed(const char& input);
 
-            void buttonPressed(const KeyEvent& evt);
             void buttonHeld   (const KeyEvent& evt);
             void processKey   (const KeyEvent& evt);
@@ -174,4 +178,5 @@
             std::list<BaseInputBufferListenerTuple*> listeners_;
             std::string allowedChars_;
+            unsigned int maxLength_;
             unsigned int cursor_;
 
Index: code/branches/pickup2/src/libraries/core/input/InputDevice.h
===================================================================
--- code/branches/pickup2/src/libraries/core/input/InputDevice.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/input/InputDevice.h	(revision 6412)
@@ -203,4 +203,5 @@
         {
             // remove the button from the pressedButtons_ list
+            bool found = false;
             for (unsigned int iButton = 0; iButton < pressedButtons_.size(); iButton++)
             {
@@ -208,7 +209,10 @@
                 {
                     pressedButtons_.erase(pressedButtons_.begin() + iButton);
+                    found = true;
                     break;
                 }
             }
+            if (!found)
+                return; // We ignore release strokes when the press was not captured
 
             // Call states
Index: code/branches/pickup2/src/libraries/core/input/InputHandler.h
===================================================================
--- code/branches/pickup2/src/libraries/core/input/InputHandler.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/input/InputHandler.h	(revision 6412)
@@ -73,4 +73,9 @@
             , modifiers_(0)
         { }
+        KeyEvent(KeyCode::ByEnum key, unsigned int text, int modifiers)
+            : key_(key)
+            , text_(text)
+            , modifiers_(modifiers)
+        { }
         bool operator==(const KeyEvent& rhs) const
             { return rhs.key_ == key_; }
@@ -97,8 +102,8 @@
 
         Derive from this class if you wish to receive input events.
-        But keep in mind that this is pointless wihtout first having an InputState.
+        But keep in mind that this is pointless without first having an InputState.
     @note
         The definitions for the button events with the weird arguments are simply
-        to avoid redunant code in the input devices.
+        to avoid redundant code in the input devices.
     */
     class _CoreExport InputHandler
Index: code/branches/pickup2/src/libraries/core/input/InputManager.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/input/InputManager.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/input/InputManager.cc	(revision 6412)
@@ -48,5 +48,5 @@
 #include "core/ConfigValueIncludes.h"
 #include "core/ConsoleCommand.h"
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/Functor.h"
 #include "core/GraphicsManager.h"
@@ -170,5 +170,5 @@
         if (mouseMode_ == MouseMode::Exclusive || GraphicsManager::getInstance().isFullScreen())
         {
-            if (CommandLine::getValue("keyboard_no_grab").getBool())
+            if (CommandLineParser::getValue("keyboard_no_grab").getBool())
                 paramList.insert(std::make_pair("x11_keyboard_grab", "false"));
             else
@@ -190,5 +190,5 @@
             // Exception-safety
             Loki::ScopeGuard guard = Loki::MakeGuard(OIS::InputManager::destroyInputSystem, oisInputManager_);
-            CCOUT(ORX_DEBUG) << "Created OIS input manager." << std::endl;
+            CCOUT(4) << "Created OIS input manager." << std::endl;
 
             if (oisInputManager_->getNumberOfDevices(OIS::OISKeyboard) > 0)
@@ -232,5 +232,5 @@
         }
         else
-            CCOUT(ORX_WARNING) << "Warning: No mouse found! Proceeding without mouse support." << std::endl;
+            CCOUT(2) << "Warning: No mouse found! Proceeding without mouse support." << std::endl;
     }
 
@@ -275,5 +275,5 @@
         // destroy all user InputStates
         while (statesByName_.size() > 0)
-            this->destroyStateInternal((*statesByName_.rbegin()).second);
+            this->destroyStateInternal(statesByName_.rbegin()->second);
 
         if (!(internalState_ & Bad))
@@ -297,5 +297,5 @@
             if (device == NULL)
                 continue;
-            std::string className = device->getClassName();
+            const std::string& className = device->getClassName();
             try
             {
@@ -366,5 +366,5 @@
     // ############################################################
 
-    void InputManager::update(const Clock& time)
+    void InputManager::preUpdate(const Clock& time)
     {
         if (internalState_ & Bad)
@@ -466,5 +466,5 @@
     @brief
         Updates the currently active states (according to activeStates_) for each device.
-        Also, a list of all active states (no duplicates!) is compiled for the general update().
+        Also, a list of all active states (no duplicates!) is compiled for the general preUpdate().
     */
     void InputManager::updateActiveStates()
@@ -508,5 +508,5 @@
         if (mouseStates.empty())
             requestedMode = MouseMode::Nonexclusive;
-        else 
+        else
             requestedMode = mouseStates.front()->getMouseMode();
         if (requestedMode != MouseMode::Dontcare && mouseMode_ != requestedMode)
@@ -554,5 +554,5 @@
     }
 
-    //! Gets called by WindowEventListener upon focus change --> clear buffers 
+    //! Gets called by WindowEventListener upon focus change --> clear buffers
     void InputManager::windowFocusChanged()
     {
@@ -579,5 +579,5 @@
     InputState* InputManager::createInputState(const std::string& name, bool bAlwaysGetsInput, bool bTransparent, InputStatePriority priority)
     {
-        if (name == "")
+        if (name.empty())
             return 0;
         if (statesByName_.find(name) == statesByName_.end())
@@ -631,9 +631,14 @@
                 {
                     // not scheduled for destruction
-                    // prevents a state being added multiple times
+                    // prevents a state from being added multiple times
                     stateEnterRequests_.insert(it->second);
                     return true;
                 }
             }
+            else if (this->stateLeaveRequests_.find(it->second) != this->stateLeaveRequests_.end())
+            {
+                // State already scheduled for leaving --> cancel
+                this->stateLeaveRequests_.erase(this->stateLeaveRequests_.find(it->second));
+            }
         }
         return false;
@@ -658,4 +663,9 @@
                 return true;
             }
+            else if (this->stateEnterRequests_.find(it->second) != this->stateEnterRequests_.end())
+            {
+                // State already scheduled for entering --> cancel
+                this->stateEnterRequests_.erase(this->stateEnterRequests_.find(it->second));
+            }
         }
         return false;
